<template>
  <Card :title="$t('title')">
    <NestedPermission
      v-for="permission in rootPermissions"
      :key="permission.id"
      :permission="permission"
      :level="0"
    />
  </Card>
</template>

<script lang="ts">
import {
  Component, ProvideReactive, Vue,
} from 'vue-property-decorator';
import { getModule } from 'vuex-module-decorators';
import PermissionsModule from '@/store/modules/permissions';
import Card from '@/components/card/Card.vue';
import NestedPermission from '@/containers/NestedPermission.vue';

@Component({
  name: 'PermissionsList',
  components: { NestedPermission, Card },
})
export default class PermissionsList extends Vue {
  module = getModule(PermissionsModule, this.$store);

  @ProvideReactive('permissionsTree')
  get permissionsTree() {
    return this.module.permissionsTree;
  }

  @ProvideReactive('changePermission')
  changePermission(index: number) {
    this.module.updatePermission(index);
  }

  get rootPermissions() {
    return this.permissionsTree.root;
  }
}
</script>
